#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum GeoLineStyle {
    #[deprecated(note = "Use SOLID instead.")]
    #[serde(rename = "POINTS")]
    Points,
    #[serde(rename = "SOLID")]
    Solid,
    #[serde(rename = "DASH")]
    Dash,
    #[serde(rename = "NONE")]
    None,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl GeoLineStyle {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            #[allow(deprecated)]
            GeoLineStyle::Points => "POINTS",
            GeoLineStyle::Solid => "SOLID",
            GeoLineStyle::Dash => "DASH",
            GeoLineStyle::None => "NONE",
            GeoLineStyle::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for GeoLineStyle {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for GeoLineStyle {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for GeoLineStyle {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<GeoLineStyle, conjure_object::plain::ParseEnumError> {
        match v {
            #[allow(deprecated)]
            "POINTS" => Ok(GeoLineStyle::Points),
            "SOLID" => Ok(GeoLineStyle::Solid),
            "DASH" => Ok(GeoLineStyle::Dash),
            "NONE" => Ok(GeoLineStyle::None),
            v => v.parse().map(|v| GeoLineStyle::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for GeoLineStyle {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<GeoLineStyle, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the GeoLineStyle enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
